/*	$Csoft: table.h,v 1.2 2003/12/11 04:49:36 vedge Exp $	*/
/*	Public domain	*/

#ifndef _CGI_TABLE_H_
#define _CGI_TABLE_H_

#define TABLE_NBUCKETS		1
#define TABLE_MAX_FIELDS	8

struct table_ent {
	char	 *key;				/* First field */
	char	 *fields[TABLE_MAX_FIELDS];	/* Extra fields */

	SLIST_ENTRY(table_ent)	ents;
	SLIST_ENTRY(table_ent)	bents;
};

struct table_bucket {
	SLIST_HEAD(, table_ent)  ents;
	unsigned int		nents;
};

struct table {
	char	*data;			 /* Mmapped file */
	size_t	 data_len;		 /* Length of mapping */
	int	 nfields;		 /* Number of fields per entry */

	struct table_bucket	buckets[TABLE_NBUCKETS]; /* Hash table */
	SLIST_HEAD(, table_ent)	ents;			 /* Flat list */
};

#define TABLE_FOREACH(ent, table)				\
	SLIST_FOREACH((ent), &(table)->ents, ents)

#define TABLE_FOREACH_LANG(q, ent, table)			\
	SLIST_FOREACH((ent), &(table)->ents, ents) {		\
		if (strcmp((ent)->fields[0], (q)->lang) != 0)	\
			continue;

__BEGIN_DECLS
void		  table_init(struct table *);
struct table	 *table_load(const char *, int);
int		  table_save(struct table *, const char *);
void		  table_destroy(struct table *);

struct table_ent *table_lookup(struct table *, const char *, u_int);
char		 *table_lookup_field(struct table *, const char *, int);

int	 table_copy_field(struct table *, const char *, int, char *, size_t)
	     BOUNDED_ATTRIBUTE(__string__, 4, 5);

int	 table_insert(struct table *, struct table_ent *);
int	 table_remove(struct table *, const char *);
__END_DECLS

#endif	/* _CGI_TABLE_H_ */
